#pragma once

// ESP32 specific
// #include "esp_log.h"

// C++ system level
#include <vector>
#include <string>
#include <cstring>

// project specific
#include "SpiderLib/NumberTypes.hpp"


namespace SpiderLib {

  namespace Util {

    std::vector<std::string> split(const std::string& s, char delim);


    template< template<typename> typename T>
    std::string join(T<std::string>& collection, const std::string& delimiter) {

      u32 length = 0;

      // caching this temporarily
      // TODO: do we need this or would the compiler be smart enough to cache it itself?
      // or couldn't he cache it itself because C++ is strict and it is a method-call?
      // questions over questions………
      u32 delimiterLength = delimiter.length();

      for (auto const& item : collection) length += item.length() + delimiterLength;  // TODO: replace delimiterLength -> delimiter.length()  ?


      length++;
      char str[length];
      char* ptr = str;
      std::memset(str, 0x00, length);

      for (auto const& item : collection) {
        
        u32 len = item.length();

        std::memcpy(ptr, item.c_str(), len);
        ptr += len;

        std::memcpy(ptr, delimiter.c_str(), delimiterLength);
        ptr += delimiterLength;
      }

      ptr -= delimiterLength;
      std::memset(ptr, 0x00, delimiterLength);  // clear out the trailing delimiter

      return std::string(str);
    }


  }
}
