#pragma once

// C++ system level
#include <string>
#include <cinttypes>

// ESP32 specific
// #include ""

// project specific
// #include ""

// qthing stuff
// #include <qthing>


namespace SiliconTorch {

  namespace CyanBusTX {

    // CyanBus payload MTU
    // This leads to ~54 P/s @ 2 MBaud at 100% load
    constexpr uint32_t MTU = 4096;


    class CyanBusTX {
      public:
        CyanBusTX(uint8_t tx, uint8_t rx, uint8_t de, uint8_t re, uint32_t baudRate = 115200, uint8_t uartChannel = 1);

        uint32_t getBaudRate();
        void setBaudRate(uint32_t baudRate);

        void write(std::string& data, bool _break = false);
        void write(const uint8_t* data, uint32_t length, bool _break = false);

        void sendBreak();

      private:

        uint8_t uartChannel;
        uint8_t tx, rx, de, re;

        void txEN(bool state);
        void rxEN(bool state);
        void txrxEN(bool state);

    };
  }
}
